#!/usr/local/bin/perl
#
# PPEH ver 0.75 --- "Pigeon Post" Error Handler
#                ( 1999.07.02 named by Masato MINDA <minmin@wide.ad.jp> )
# Copyright (c)1999 by Kazunori ANDO <ando@kk.iij4u.or.jp> all rights reserved.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
################
$PPEH_VERSION = "0.752";
################
$DIR = $ARGV[0];
if ( $0 =~ /^(\S+)\/ppeh\.pl/ ){ $ORIGIN = $1 };
$LOCK_SH = 1;
$LOCK_EX = 2;
$LOCK_NB = 4;
$LOCK_UN = 8;
$locktmp = "L$$";
##### main #####
&ReadSiteConfig;
&ChdirByArg;         # Chdir to $DIR
&PPLockWait;         # Lock 
&ReadConfig;         # Read config.ph
&ParseInput(*e);     # Read input and set %e hash
#&DebugPrint(*e);
&Summarize(*e);
&UnlockDone;         # Unlock
################

sub ReadSiteConfig{
    $0 = "ReadSiteConfig";
    unshift(@INC,$ORIGIN);
    eval("require(\"sitedef.ph\")");
    if ($@) {
	&Log("$0:ERROR:$@");
	print STDERR $@;
	exit 2;
    }
    return 1;
}

sub ChdirByArg{
    $0 = "ChdirByArg";
    if ((-d $DIR) && (-x $DIR)){
	unshift(@INC, $DIR);
	chdir $DIR;
    }else{
	print STDERR "$0:WARN: \$DIR is not given or Can't chdir.";
	exit 2;
    }
    return 1;
}

sub ReadConfig{
    $0 = "ReadConfig";
    eval("require(\"config.ph\")");
    if ($@) {
	&Log("$0:ERROR:$@");
	print STDERR $@;
        &UnlockDone2;
    }
    return 1;
}

sub ParseInput{
    $0 = "ParseInput";
    local(*e) = @_;
    local(@header);
    local($mpp,$mpi,$h,$c,$hc);
    $/ = "\n\n";
    $e{'Header'} = <STDIN>;
    $/ = "\n";
    $e{'size:header'} = length($e{'Header'});
    @header = split(/\n/,$e{'Header'});
    foreach (@header){
	if (/^([^\s\:]+)\:\s*(.*)/){
	    $h = $1;
	    $c = $2;
	    # field-name covert to unified form
	    $horg = $h;
	    $h =~ tr/A-Z/a-z/;
	    # message-id -> Message-id
	    if ( $h =~ /^(.)(.*)/ ){
                $hc = $1;
                $hc =~ tr/a-z/A-Z/;
                $h = $hc.$2;
	    }
	    # Message-id -> Message-Id
	    while ( $h =~ /^(.+)(\-[a-z])(.+)/ ){
                $hc = $2;
                $hc =~ tr/a-z/A-Z/;
                $h = $1.$hc.$3;
	    }
	    $e{"OH:$h"} = $horg;
	    if ((length($e{"H:$h"}) > 0)&&(length($c) > 0)){
		$e{"H:$h"} .= "$_\n";
	    }elsif((length($h) > 0) && (length($c) > 0)){ 
		$e{"H:$h"} .= "$c\n";
	    }
	}elsif(/^(\s+.*)/){
	    if ($h ne ""){
		$e{"H:$h"} .= "$_\n";
	    }else{
		$e{'bogus'} .= "$_\n";
	    }
	}else{
	    $e{'bogus'} .= "$_\n";
	}
    }
    while(<STDIN>){
	$e{'Body'} .= $_;
	$e{'line:body'}++;
	$e{'size:body'} += length($_);
    }
    if ($CHKSUMTYPE eq 'SHA1') {
	use Digest::SHA1 qw(sha1_base64);
	$e{'checksum:body'} = sha1_base64($e{'Body'});
    }elsif($CHKSUMTYPE eq 'MD5'){
	use Digest::MD5  qw(md5_base64);
	$e{'checksum:body'} = md5_base64($e{'Body'});
    }else{
	$e{'checksum:body'} = sprintf("%011d-%011d",$e{'size:body'},unpack("%31C*",$e{'Body'}));
    }
    $e{'size'} = $e{'size:header'} + $e{'size:body'};
    &Log("$0:FROM: $e{'H:From'}");
    &Log("$0:DATA: header:$e{'size:header'} + body:$e{'size:body'} = $e{'size'} bytes");
    #
    # multipart errorform analyze(sendmail type)
    #
    if (($e{'H:Content-Type'} =~ /multipart\/report\;/i) &&
	($e{'H:Content-Type'} =~ /report\-type\=delivery\-status\;/i) &&
	($e{'H:Content-Type'} =~ /boundary\=[\"]*([^\"\;]+)[\"]*/i)){ #"
	$e{'mp:boundary'} = $1;
	$e{'size:mp:boundary'} = length($e{'mp:boundary'});
	# partscan
	$mc = 0; $mcs = 'mp:00';
	foreach $line (split(/\n/,$e{'Body'})){
	    if ($line eq "--$e{'mp:boundary'}--"){last;};
	    if ($line eq "--$e{'mp:boundary'}"){
		$mc++;
		$mcs = sprintf("mp:%d",$mc);
	    }
	    if ($mc == 1){
		if ($line =~ /^\s+\(expanded from\:\s+\<([^\>]+)\>\)/){
		    $rcpt = $1;
		    $roots{$rcpt} = $1;
		}
		if ($line =~ /^(\d+) \<([^\>\@]+\@[^\>]+)\>\.\.\.\s*(.*)/){
		    $rcpt = $roots{$2} || $roots{$rcpt} || $2;
		    $smtperr{$rcpt} = "$1: $3";
		}elsif ($line =~ /^(\d+) ([^\@]+\@.*)\.\.\.\s*(.*)/){
		    $rcpt = $roots{$2} || $roots{$rcpt} || $2;
		    $smtperr{$rcpt} = "$1: $3";
		}elsif ($line =~ /^(\d+) \"([^\>\@]+\@[^\>]+)\"\.\.\.\s*(.*)/){ #"
		    $smtperr{$rcpt} = "$1: $3";
		}
	    }elsif($mc == 2){
		if ($line =~ /^Reporting-MTA\:\s*(\w+)\;\s*([\d\[\]\w\.\-]+)/i){
		    $e{'ERR:repmta'} = $2;
		}
		if ($line =~ /^Received-From-MTA\:\s*(\w+)\;\s*([\[\]\d\w\.\-]+)/i){
		    $e{'ERR:recmta'} = $2;
		}
		if ($line =~ /^Final-Recipient\:\s*(\w+)\;\s*\<*([\w\@\.\-]+)\>*/i){
		    $rcpt = $roots{$2} || $2;
		}
                if ($rcpt !~ /\@docomo.ne.jp/){
		    if ($line =~ /^Status\:\s*(\d\.\d\.\d)/i){
			$rerr{$rcpt} = $1;
		    }
		    if ($line =~ /^Remote-MTA\:\s*(\w+)\;\s*([\d\[\]\w\.\-]+)/i){
			$rerr{$rcpt} .= ":$2";
		    }
		}else{
		    if ($line =~ /^Status\:\s*(\d\.\d\.\d)/i){
			$status = $1;
		    }
		    if ($line =~ /^Diagnostic-Code\:\s*\S+\s+\d+\s+\<[^\>]+\>\.\.\.\s+([^\(]+)\([^\)]+\)/i){
			$erraddr = $1;
			foreach my $adom (split(/\s+/,$erraddr)){
			    if ($adom =~ /\@/){
				$rcpt = $adom;
				$rerrc{$rcpt} = $status;
				$rerr{$rcpt} = $status;
			    }
			}
		    }
		}
		if ($line =~ /^Last-Attempt-Date\:/){
		    if ($rerr{$rcpt} =~ /^\d\.\d\.\d$/){
			$rerr{$rcpt} .= ":";
			$rerr{$rcpt} .= $e{'ERR:repmta'};
		    }
		}
	    }elsif($mc == 3){
		if ($line =~ /^X-Sequence\:\s*(\S+)\s+(\d+)/i){
		    $e{'ERR:article'} = "$1 $2";
		}
	    }		
	    $e{$mcs} .= "$line\n";
	}
	$e{'mp'} = $mc;
	delete $e{'mp:00'};
	&Log("$0:MIME: multipart $mc parts in message");
	
	for ($i = 1; $i <= $mc ; $i++){
	    $mcs = sprintf("mp:%d",$i);
	    $e{"size:$mcs"} = length($e{$mcs});
	}
    }else{
	#
	# Old type
	#
	# Head analyze
	if ($e{'H:From'} =~ /\s*([^\<]+)\<([\w\-]+)\@([\[\]\d\w\-\.]+)\>/i){
	    $e{'ERR:repmta'} = $3;
	}elsif($e{'H:From'} =~ /([\w\-]+)\@([\[\]\d\w\-\.]+)/i){
	    $e{'ERR:repmta'} = $2;
	    # NIFTY special
	    if ($e{'ERR:repmta'} =~ /nifty\.ne\.jp/i){
		if ($e{'H:Subject'} =~ /Returned mail\: (\S+) (.*)/){
		    $rerr{"$1\@nifty\.ne\.jp"} = "5.0.0:".$e{'ERR:repmta'};
		}
	    }
	}
	# Body analyze
	foreach $line (split(/\n/,$e{'Body'})){
	    if ($line =~ /^X-Sequence\:\s*(\S+)\s+(\d+)/i){
		$e{'ERR:article'} = "$1 $2";
	    }elsif ($line =~ /^(\d+) \<([^\>\@]+\@[^\>]+)\>\.\.\.\s*(.*)/){
		$rcpt = $roots{$2} ||$roots{$rcpt} || $2;
		$smtperr{$rcpt} = "$1: $3";
		if ($rerr{$rcpt}){
		    $rerr{$rcpt} = "5.0.0:".$rerr{$rcpt};
		}else{
		    $rerr{$rcpt} = "5.0.0:".$e{'ERR:remmta'};
		}
	    }elsif ($line =~ /^(\d+) ([^\@]+\@.*)\.\.\.\s*(.*)/){
		$rcpt = $roots{$2} || $roots{$rcpt} || $2;
		$smtperr{$rcpt} = "$1: $3";
		if ($rerr{$rcpt}){
		    $rerr{$rcpt} = "5.0.0:".$rerr{$rcpt};
		}else{
		    $rerr{$rcpt} = "5.0.0:".$e{'ERR:remmta'};
		}
	    }elsif ($line =~ /^\s+\(expanded from\:\s+\<([^\>]+)\>\)/){
		$rcpt = $1;
		$roots{$rcpt} = $1;
	    }elsif ($line =~ /^\.\.\.\s*while talking to ([\w\-\.]+)\:/){
		$dum = $1;
		chop($dum);
		$rerr{$rcpt} = $dum;
		$e{'ERR:remmta'} = $dum;
	    }elsif ($line =~ /^from ([\w\-\.]+)\s+(\[[\d\.]+\])/){
		$e{'ERR:recmta'} = $1;
	    }
	}
	
    }
    return 1;
}

sub Summarize{
    $0 = "Summarize";
    local(*e) = @_;
    &ELog("RT:$e{'ERR:article'}:$e{'ERR:recmta'}->$e{'ERR:repmta'}->");
    foreach $rc (keys(%rerr)){
	next if ($rc eq "");
	&ELog("ER:$e{'ERR:article'}:$rerr{$rc}:$rc:$smtperr{$rc}");
    }
}

sub PPLockWait{
    $0 = "PPLockWait";
    local($wait) = 0;
    unless(-d "$Savedir"){
	mkdir("$Savedir",0750);
	&Log("$0:FILE: \$Savedir($Savedir) is created.");
    }
    if ($USE_LOCKFILE == 1){
	while (-f "$Savedir/.lockfile"){
	    sleep 15;
	    $wait++;
	    if ($wait > 20){
		&Log("$0:Fail: Timeout to wait unlock ($Savedir/.lockfile)");
		print STDERR "$0:Fail: Timeout to wait unlock ($Savedir/.lockfile)\n";
		exit 2;
	    }
	}
	open (LOCK, "> $Savedir/$locktmp");
	print LOCK "$$\n";
	close (LOCK);
	while (!link("$Savedir/$locktmp", "$Savedir/.lockfile")){
	    sleep 15;
	    $wait++;
	    if ($wait > 40){
		&Log("$0:Fail: Timeout to link ($Savedir/.lockfile)");
		print STDERR "$0:Fail: Timeout to link ($Savedir/.lockfile)\n";
		exit 2;
	    }
	}
	&Log("$0:LOCK: lock Lockfile($Savedir/.lockfile) -- session start");
    }else{
	while (!open(LOCK,"+< config.ph")){
	    sleep 3;
	    $wait++;
	    if ($wait > 100){
		&Log("$0:Fail: Timeout to open (config.ph)");
		print STDERR "$0:Fail: Timeout to open (config.ph)\n";
		exit 2;
	    }
	}
	while (!flock(LOCK,$LOCK_EX)){
	    sleep 3;
	    $wait++;
	    if ($wait > 200){
		&Log("$0:Fail: Timeout to lock (config.ph)");
		print STDERR "$0:Fail: Timeout to lock (config.ph)\n";
		exit 2;
	    }
	}
	&Log("$0:LOCK: lock config.ph -- session start");
    }
    return 1;
}

sub UnlockDone{
    $0 = "UnlockDone";
    &Log("$0:DONE: unlock -- session completed.");
    if ($USE_LOCKFILE == 1){
	unlink("$Savedir/.lockfile");
	unlink("$Savedir/$locktmp");
    }else{
	unless (flock(LOCK,$LOCK_UN)){
	    &Log("$0:Fail: Can't unlock (config.ph)") if $debug;
	}
	close(LOCK);
    }
    exit 0;
}

sub UnlockDone2{
    $0 = "UnlockDone";
    &Log("$0:DONE: unlock2 -- session aborted.");
    if ($USE_LOCKFILE == 1){
	unlink("$Savedir/.lockfile");
	unlink("$Savedir/$locktmp");
    }else{
	unless (flock(LOCK,$LOCK_UN)){
	    &Log("$0:Fail: Can't unlock (config.ph)") if $debug;
	}
	close(LOCK);
    }
    exit 2;
}

sub DebugPrint{
    local(*e) = @_;
    foreach $key (sort(keys(%e))){
	print "-------- $key:\n$e{$key}\n";
    }
    foreach $key (sort(keys(%rerr))){
	print "-------- $key:\n$rerr{$key}\n";
    }
    foreach $key (sort(keys(%smtperr))){
	print "-------- $key:\n$smtperr{$key}\n";
    }
    foreach $key (sort(keys(%roots))){
	print "-------- $key:\n$roots{$key}\n";
    }
    return 1;
}
    

sub ELog{
    local($s) = @_;
    local($Logfile) = $ERRORLOG || "pp.err";
    ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0..6];
    $now = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
		   1900 + $year, $mon + 1, $mday, $hour, $min ,$sec);
    $s =~ s/\r//;
    $s =~ s/\n//;
    open(LOG,">>$Logfile");
    print LOG "$now $s\n";
    close(LOG);
    return 1;
}

sub Log{
    local($s) = @_;
    local($Logfile) = $PPEHLOG || "ppeh.log";
    ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0..6];
    $now = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
		   1900 + $year, $mon + 1, $mday, $hour, $min ,$sec);
    $s =~ s/\r//;
    $s =~ s/\n//;
    open(LOG,">>$Logfile");
    print LOG "$now $s\n";
    close(LOG);
    return 1;
}
